<?php
/**
  * osCommerce Online Merchant
  *
  * @copyright (c) 2016 osCommerce; https://www.oscommerce.com
  * @license MIT; https://www.oscommerce.com/license/mit.txt
  */

  class ht_cookie {
    var $code = 'ht_cookie';
    var $group = 'header_tags';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->title = MODULE_HEADER_TAGS_COOKIE_TITLE;
      $this->description = MODULE_HEADER_TAGS_COOKIE_DESCRIPTION;

      if ( defined('MODULE_HEADER_TAGS_COOKIE_STATUS') ) {
        $this->sort_order = MODULE_HEADER_TAGS_COOKIE_SORT_ORDER;
        $this->enabled = (MODULE_HEADER_TAGS_COOKIE_STATUS == 'True');
      }
    }

    function execute() {
      global $oscTemplate;

      $message = MODULE_HEADER_TAGS_COOKIE_MESSAGE_TEXT;
      $dismiss = MODULE_HEADER_TAGS_COOKIE_DISMISS_TEXT;
      $more    = MODULE_HEADER_TAGS_COOKIE_MORE_TEXT;
      $link    = tep_href_link(MODULE_HEADER_TAGS_COOKIE_PAGE);
      
      $static = false;
      switch (MODULE_HEADER_TAGS_COOKIE_POSITION) {
      case "Banner top":
          $position = '"top"';
          break;
      case "Banner bottom":
          $position = '"bottom"';
          break;          
      case "Floating left":
          $position = '"bottom-left"';
          break;
      case "Floating right":
          $position = '"bottom-right"';
          break;
      case "Banner top (pushdown)":
          $position = '"top"';
          $static = true;
          break;          
      default:
          $position = '"bottom"';
      }      
      if ($static) {
        $position .= ',"static": true';
      }
      switch(MODULE_HEADER_TAGS_COOKIE_LAYOUT) {
      case "Block":
          $layout = "block";
          break;
      case "Classic":
          $layout = "classic";          
          break;
      case "Edgeless":
          $layout = "edgeless";
          break;
      default:
          $layout = "block";
      }
      require "ext/cookieconsent/3.1.0/cookie.consent.palettes.php";
      $palette = constant(strtoupper('MODULE_HEADER_TAGS_COOKIE_' . str_replace(' ', '_',MODULE_HEADER_TAGS_COOKIE_PALETTE)));
      
      $output  = <<<EOD
<link rel="stylesheet" type="text/css" href="ext/cookieconsent/3.1.0/cookieconsent.min.css" />
<script src="ext/cookieconsent/3.1.0/cookieconsent.min.js"></script>
<script>
window.addEventListener("load", function(){
window.cookieconsent.initialise({
  "position": {$position},
  "theme": "{$layout}",
  "palette": {$palette},
  "content": {
    "message": "{$message}",
    "dismiss": "{$dismiss}",
    "link": "{$more}",
    "href": "{$link}",
    "target": "_self"
  }
})});
</script>
EOD;

      $oscTemplate->addBlock($output . "\n", $this->group);
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_HEADER_TAGS_COOKIE_STATUS');
    }

    function install() {
	  
	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Cookie Compliance Module', 'MODULE_HEADER_TAGS_COOKIE_STATUS', 'True', 'Do you want to enable this module?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");

	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Position', 'MODULE_HEADER_TAGS_COOKIE_POSITION', 'Banner top', 'Select Position', '6', '1', 'tep_cfg_select_option(array(\'Banner bottom\', \'Banner top\', \'Floating left\', \'Floating right\', \'Banner top (pushdown)\'), ', now())");
	  
	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Layout', 'MODULE_HEADER_TAGS_COOKIE_LAYOUT', 'Block', 'Select Layout', '6', '1', 'tep_cfg_select_option(array(\'Block\', \'Classic\', \'Edgeless\'), ', now())");
	  
	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Palette', 'MODULE_HEADER_TAGS_COOKIE_PALETTE', 'Palette 1', 'Select Palette (<a style=\"font-weight:bold\" href=\"ext/cookieconsent/3.1.0/cookie.consent.palettes.html\" target=\"_blank\">See examples here)</a>
', '6', '1', 'tep_cfg_select_option(array(\'Palette 1\', \'Palette 2\', \'Palette 3\', \'Palette 4\', \'Palette 5\', \'Palette 6\', \'Palette 7\', \'Palette 8\', \'Palette 9\', \'Palette 10\', \'Palette 11\', \'Palette 12\', \'Palette 13\', \'Palette 14\', \'Palette 15\', \'Palette 16\'), ', now())");
	  
	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Cookie Policy Page', 'MODULE_HEADER_TAGS_COOKIE_PAGE', 'privacy.php', 'The Page on your site that has details of your Cookie Policy.', '6', '0', now())");
	  
	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_HEADER_TAGS_COOKIE_SORT_ORDER', '900', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_HEADER_TAGS_COOKIE_STATUS', 'MODULE_HEADER_TAGS_COOKIE_POSITION','MODULE_HEADER_TAGS_COOKIE_LAYOUT','MODULE_HEADER_TAGS_COOKIE_PALETTE', 'MODULE_HEADER_TAGS_COOKIE_PAGE', 'MODULE_HEADER_TAGS_COOKIE_SORT_ORDER');
    }
  }
